﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;
using System.Diagnostics;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Core;

namespace WC_DropLines
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.ChartType = ChartType.ScatterChart;
            ultraChart1.Series.Add(GetScatterSeries());
            ultraChart1.DataBind();

            ultraChart1.ScatterChart.ConnectWithLines = true;
            ultraChart1.ScatterChart.Icon = SymbolIcon.Diamond;

            ultraChart1.Axis.Y.RangeType = AxisRangeType.Custom;
            ultraChart1.Axis.Y.RangeMin = 0;
            ultraChart1.Axis.Y.RangeMax = 20;

            ultraChart1.Axis.X.RangeType = AxisRangeType.Custom;
            ultraChart1.Axis.X.RangeMin = 4;
            ultraChart1.Axis.X.RangeMax = 15;
        }

        private XYSeries GetScatterSeries()
        {
            XYSeries series = new XYSeries();
            series.Points.Add(new XYDataPoint(5, 12, "Point A", false));
            series.Points.Add(new XYDataPoint(8, 10, "Point B", false));
            series.Points.Add(new XYDataPoint(9, 14, "Point C", false));
            series.Points.Add(new XYDataPoint(10.5, 12, "Point D", false));
            series.Points.Add(new XYDataPoint(11, 16, "Point E", false));
            series.Points.Add(new XYDataPoint(14, 13, "Point F", false));
            return series;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            var pointSet = e.SceneGraph.OfType<PointSet>().FirstOrDefault();

            if (pointSet != null)
            {
                foreach (var point in pointSet.points)
                {
                    var yAxis = e.Grid["Y"] as IAdvanceAxis;
                    var xAxis = e.Grid["X"] as IAdvanceAxis;

                    var values = point.Value as object[];
                    var valueX = values[0];
                    var valueY = values[1];
                    
                    var coordY = yAxis.Map(valueY);
                    var coordX = xAxis.Map(valueX);
                    var xAxisYCoord = yAxis.MapMinimum;

                    Line dropLine = new Line(new Point((int)coordX, (int)coordY), new Point((int)coordX, (int)xAxisYCoord));
                    dropLine.PE.Stroke = Color.Red;
                    dropLine.PE.StrokeWidth = 2;
                    dropLine.lineStyle.DrawStyle = LineDrawStyle.Dash;                  
                    e.SceneGraph.Add(dropLine);
                }
            }
            
        }
    }
}
